
;-----------------------------------------------------------------------------
;			Grayscale Compressed Pictures
;         	    for use with greylib by Robert Taylor
;			    (C)1996 by Andreas Ess
;
;This is a routine which decompresses a picture stored in HL and puts it at
;Page1Addr & Page2Addr.
;This is based on ZCP by Stephane Jantzen. However, I've completely rewritten
;it. If you find a way to do this faster, send me snail mail:
; Andreas Ess
; Tufers 156
; A-6811 Goefis
; Austria/Europe
;or wait until I get internet access
;NOTE: This routine was not written to be small, but to be quite fast.
;      (However, try to optimize it using the EXX instruction, if you've
;	got time)
;      Andreas Ess isn't liable for any damages resulted by this piece of code.
;-----------------------------------------------------------------------------
#define GCPPoint1 .db $28,$03 \ ld a, (de) \ or c \ ld (de), a
#define GCPPoint2 .db $28,$03 \ ld a, (hl) \ or c \ ld (hl), a

;
;DeGCP: decompresses picture at %HL on (Page1Addr) & (Page2Addr) with
;       starting offset %BC
;
DeGCP:
 push hl
 pop  ix
 ex   de, hl
 ld   hl, (Page1Addr)           ;IX -> data
 add  hl, bc			;DE -> first page offset
 ex   de, hl
 ld   hl, (Page2Addr)           ;HL -> second page offset
 add  hl, bc
 ld   c, 128
 dec  ix
G_DLoop:
 inc  ix
 ld   a, (ix) 			;get databyte
 and  a  			;00h -> finished
 JUMP_Z(G_EndDecomp)
 ld   (Data), a			;save data byte
 bit  7, a                      ;bit 7: 0 = RLE; 1 = RAW MODE
 jr   z, G_RLE			;Z is set if bit is 0...
 ld   b, a
 and  %00100000
 GCPPoint1
 ld   a, b                      ;load color into a
 and  %00010000
 GCPPoint2
 rrc  c
 jr   nc, CheckPoint2
 inc  de
 inc  hl
CheckPoint2:
 ld   a, b
 ld   (Color), a
 and  %00001000
 GCPPoint1          		;put pixel on page 1 -> darkgray, black
 ld   a, b                      ;load color into a
 and  %00000100
 GCPPoint2          		;put pixel on page 2 -> lightgray, black
 rrc  c
 jr   nc, CheckPoint3
 inc  de
 inc  hl
CheckPoint3:
 ld   a, b
 and  %00000010
 GCPPoint1          		;put pixel on page 1 -> darkgray, black
 ld   a, b                      ;load color into a
 and  %00000001
 GCPPoint2          		;put pixel on page 2 -> lightgray, black
 rrc  c
 jr   nc, G_DLoop
 inc  de
 inc  hl
 jr   G_DLoop
G_RLE:
 ld   (Color), a		;bits 5&6 contain grafix data
 ld   a, (Data)
 and  %00011111			;the bits from 0-4 the counter...
 ld   b, a
G_RLELoop:
 ld   a, (Color)                ;load color into a
 and  %01000000
 GCPPoint1
 ld   a, (Color)                ;load color into a
 and  %00100000
 GCPPoint2
 rrc  c
 jr   nc, G_DoDJNZ_RLE
 inc  de
 inc  hl
G_DoDJNZ_RLE:
 djnz G_RLELoop
 JUMP_(G_DLoop)
G_EndDecomp:
 ret
