Count = $8980
CurrPage = $8981

Page1 = $8982
Page2 = $8983
PageA = $8984
PageB = $8985
PageC = $8986
PageD = $8987

Page1Addr = $8988
Page2Addr = $898a
PageAAddr = $898c
PageBAddr = $898e
PageCAddr = $8990
PageDAddr = $8992

GrayScaleOn
	ld hl,($8be5)   ;get end of VAT
	dec hl
	dec hl          ;make sure we're clear it..

	   ; now we need to get the position of
	   ; the nearest screen boundary

	ld a,h
	sub $C  ;(3*1024)
	ld h,a
	ld l,0
	push hl

	    ;Tests if there is a space for the 1K
	    ;needed for the 2nd screen

	ld de,($8be1)
	or a
	sbc hl,de
	pop hl
	jr c,GrayError

	   ; test if our block of memory
	   ; is within the range addressable
	   ; by the LCD hardware

	and 11000000b
	cp 11000000b
	jr nz,GrayError

	   ;Save out the address of our 2nd Screen
	ld de,1024
	ld (PageBAddr),hl
	ld (Page2Addr),hl
	add hl,de
	ld (PageCAddr),hl
	add hl,de
	ld (PageDAddr),hl

	   ; It is, so save out the byte to send to port 0
	   ; to switch to our 2nd screen

	ld a,h
	and 00111111b
	ld (PageD),a
	ld (Page2),a
        sub 4
        ld (PageC),a
	ld (Page1),a

        sub 4
        ld (PageB),a

        ld hl,$fc00
        ld (PageAAddr),hl
	ld (Page1Addr),hl
        ld a,$3c
        ld (PageA),a

	xor a
	ld (CurrPage),a

        CALL_(InstallInterrupt)
        or a            ;clear carry flag - alls OK
        ret

GrayError:
	scf            ;set carry flag - Error occured
	ret


GrayScaleOff
	im 1

	ld a,$3c
	out (0),a    ;Set screen back to normal

	    ;This is just to clear the
	    ;Graph screen, so people don't
	    ;Complain about rubbish appearing
	    ;On it..

;        ld hl,GRAPH_MEM
;        ld d,h
;        ld e,l
;        inc de
;        ld (hl),0
;        ld bc,1024
;        ldir
	ret

Swap_Screens
;	ld  a, (Count)
;	and a
;	jr  nz, Swap_Screens
	ld a,(CurrPage)
	or a
	jr z,SwapIn1
SwapIn0
	ld hl,(PageAAddr)
	ld (Page1Addr),hl
	ld hl,(PageBAddr)
	ld (Page2Addr),hl
	ld a,(PageC)
	ld (Page1),a
	add a, 4
	ld (Page2),a
	xor a
	ld (CurrPage),a
	ret

SwapIn1
	inc a
	ld (CurrPage),a
	ld hl,(PageCAddr)
	ld (Page1Addr),hl
	ld hl,(PageDAddr)
	ld (Page2Addr),hl
	ld a,(PageA)
	ld (Page1),a
	ld a,(PageB)
	ld (Page2),a
	ret


InstallInterrupt

        ld      a,$088           
	ld	hl,$8700	 
	ld	(hl),a
	inc	hl
	ld	b,0
CopyLoop
	ld	(hl),a
	inc	hl
	djnz	CopyLoop


	ld	hl,(PROGRAM_ADDR)
	ld	de,Int_Rout
	add	hl,de		; get the rout we want to be called
	ld      de,$8888        ;where it gets called from
	ld      bc,Int_RoutEnd+1-Int_Rout
	ldir			; copy it there

	xor  a
	ld  (Count),a

	ld a,$87
	ld i,a

        im 2
        ret

       
Int_Rout

        push    AF

        in a,(3)
        bit 1,a           ; check that it is a vbl interrupt
        jr z,EndInt

	ld a,(Count)
	cp 2
	jr z, Disp_2

Disp_1
	inc a
	ld (Count),a
	ld a,(Page1)
	out (0),a
	jr EndInt
Disp_2
	ld  (Count), a
	ld  a,(Page2)
        out (0),a
        sub a
        ld (Count),a

EndInt
        pop     AF
        jp      $38 

Int_RoutEnd

