;
;PLAINJUMP (C) 1996 BY ANDREAS ESS
;                      TUFERS 156
;                      A-6811 GOEFIS
;                      AUSTRIA/EUROPE
;
;PLAINJUMP ][ by Andreas Ess
; Start: 14.10.1996
; updte: 16.12.1996
;

;#define _LITE

#INCLUDE "INTEL.H"
#INCLUDE "TI-85.H"

;
;Variables in text-memory:
;
;Player vars:
BALLY =         TEXT_MEM        ;used for savegame
BALLX =         TEXT_MEM+1
SCROLLY =       TEXT_MEM+2      ;position in level-y
LEVELY =        TEXT_MEM+3      ;position in level
JUMPFLAG =      TEXT_MEM+4
SPEED =         TEXT_MEM+5
LIFE =          TEXT_MEM+6
SCORE =         TEXT_MEM+7
;Enemy 0 vars:
E0_BALLY =      TEXT_MEM+9
E0_BALLX =      TEXT_MEM+10
E0_SCRLY =      TEXT_MEM+11
E0_LEVELY =     TEXT_MEM+12
;Space ship vars:
SS_POSY =       TEXT_MEM+13
SS_POSX =       TEXT_MEM+14
SS_SCRLY =      TEXT_MEM+15
SS_LEVELY =     TEXT_MEM+16
;other vars:
ACCEL =         TEXT_MEM+17
SINEPT =        TEXT_MEM+18
NOSINE =        TEXT_MEM+20
SCROLLY1 =      TEXT_MEM+21
SCROLLY2 =      TEXT_MEM+22
WHATPLAIN =     TEXT_MEM+23

BallBk = TEXT_MEM+ 100
StarBk = TEXT_MEM2+100
EnemBk = GRAPH_MEM+1023-64

SaveSize = 24

;
;VARS IN TEXT_MEM2 for functions
;
SpriteHlp =     TEXT_MEM2
SpriteHlp1 =    TEXT_MEM2+2
SprLine =       TEXT_MEM2+4
Color   =       TEXT_MEM2+5
Data    =       TEXT_MEM2+6
;FREE WORD
BallPt  =       TEXT_MEM2+9
Mask    =       TEXT_MEM2+11
KEYPRESS =      TEXT_MEM2+12
ANISCROLLC =    TEXT_MEM2+13
HiScoreTemp =   TEXT_MEM2+14
StringPlace =   TEXT_MEM2+16
ZeroByte =      TEXT_MEM2+21
ORIGLVL =       TEXT_MEM2+22
HIGHJUMP =      TEXT_MEM2+24
current_tone =  TEXT_MEM2+25
current_length = TEXT_MEM2+27
WAITORPLAY =    TEXT_MEM2+28
SONGPT =        TEXT_MEM2+29
SONGLENG =      TEXT_MEM2+31
;FREE WORD
LEVELPT =       TEXT_MEM2+35    ;pointer to level data
ANICOUNT =      TEXT_MEM2+37
GameLoad =      TEXT_MEM2+38
Help =          TEXT_MEM2+39
Bump =          TEXT_MEM2+41
Bump1 =         TEXT_MEM2+42
Bump2 =         TEXT_MEM2+43
Bump3 =         TEXT_MEM2+44
Bump4 =         TEXT_MEM2+45
Bump5 =         TEXT_MEM2+46
Bump6 =         TEXT_MEM2+47
BumpEnd =       TEXT_MEM2+48
HallCount =     TEXT_MEM2+49

MAXSPEED  = 4
BITMAPMEM = VIDEO_MEM

#define MulHL16 add  hl, hl \ add  hl, hl \ add  hl, hl \ add  hl, hl

.org 0
     ;1234567890123456789  0
.db  "PJUMP ][ v0.9b BY AE",0

;
;Program start!
;
Start:
 ld   hl, TEXT_MEM2
 ld   d, h
 ld   e, l
 inc  de
 ld   (hl), 0
 ld   bc, 167
 ldir

 CALL_(PrepFastCall)
 ld   de, (PROGRAM_ADDR)
 ld   hl, Marble0
 add  hl, de
 ld   (BallPt), hl
#ifndef _LITE
 ld   hl, Song1
 add  hl, de
 ld   (SONGPT), hl
#endif

 ld   hl, ZS_BITS
 set  0, (hl)              ;Tell ZShell to warp out...
 ld   a, 4
 out  (5), a
 CALL_(GrayScaleOn)
 JUMP_C(MemError)

TitleStart:
 ld   hl, 0
 ld   (LEVELPT), hl
Title:
 ld   a, 255
 ld   (HallCount), a
CBufC1:   call ClearDBuf
#ifndef _LITE
 ld   hl, (PROGRAM_ADDR)
 ld   de, TitlePicture
 add  hl, de
 mov  bc, 32
 CALL_(DeGCP)
#else
 ld   hl, $0400
 ld   ($800C), hl
 ld   hl, (PROGRAM_ADDR)
 ld   de, TitleText
 add  hl, de
 ROM_CALL(D_ZT_STR)
#endif

 ld   hl, $0004
 ld   ($800C), hl
 lea(Menu)
 set  3, (iy+05)
 ROM_CALL(D_ZT_STR)
 res  3, (iy+05)
C2ActC2: call Copy2Active
WaitForKey:
 CALL_(Delay)
 ld   hl, HallCount
 dec  (hl)
 jr   z, ShowHall
 call GET_KEY
 and  a
 jr   z, WaitForKey
 jr   CompareKey
ShowHall:
 set  3, (iy+5)
 CALL_(HiScoreShow)
 res  3, (iy+5)
 ld   b, 200
ShowHall_Delay:
 CALL_(Delay)
 djnz ShowHall_Delay
 jr   Title
CompareKey:
 cp   K_EXIT
 JUMP_Z(ExitGame)
 cp   K_F1
 JUMP_Z(RegularGame)
 cp   K_F2
 jr   z, LoadGame
 cp   K_F3
 jr   z, LoadLevel
 jmp  WaitForKey
;Load a saved game.
LoadGame:
 ld   hl, (LEVELPT)
 ld   a, h
 or   l
 jr   z, LoadBuiltGame
 ld   de, 512
 add  hl, de
 jr   TestLevelS
LoadBuiltGame:
 ld   hl, (PROGRAM_ADDR)
 ld   de, LevelSaved
 add  hl, de
TestLevelS:
 ld   a, (hl)
 and  a
 jnz  LoadGame0
 CALL_(Swap_Screens)
 ld   hl, NoSave
 CALL_(MesgWait)
 CALL_(Swap_Screens)
Jump2Title:
 JUMP_(Title)
LoadGame0:
 ;Copy saved game(20 bytes) to TEXT_MEM
 ld   bc, SaveSize
 ld   de, BALLY
 ldir
 ld   hl, (LEVELPT)
 ld   a, h
 or   l
 jr   nz, LoadGame1
 ld   hl, (PROGRAM_ADDR)
 ld   de, Level1
 add  hl, de
LoadGame1:
 ld   (ORIGLVL), hl
 ld   d, 0
 ld   a, (LEVELY)
 dec  a
 ld   e, a
 sla  e
 rl   d
; add  hl, de
 add  hl, de
 ld   (LEVELPT), hl
CBufC0: call ClearDBuf
DScreenC1: call DrawScreen
; ld   hl, (LEVELPT)
; inc  hl
; inc  hl
; ld   (LEVELPT), hl
 ld   bc, (BALLY)
 xor  a
 ld   (SCROLLY), a
 ld   (ANICOUNT), a
 JUMP_(St_GameLoop)
LoadLevel:
 CALL_(GrayScaleOff)
 CALL_(LoadLvl)
 ld   a, h
 or   l
 jr   z, ErrorLoad
 inc  hl
 inc  hl
 inc  hl
 ld   (LEVELPT), hl
 ld   a, 1
 ld   (GameLoad), a
 CALL_(GrayScaleOn)
 jr   Jump2Title
ErrorLoad:
 ld   hl, LoadError
 CALL_(MesgWait)
 CALL_(GrayScaleOn)
 jr   Jump2Title
RegularGame:
 ;Do some initialisation
 ld   hl, (LEVELPT)
 ld   a, h
 or   l
 jr   nz, BuiltInLevels
 ld   hl, (PROGRAM_ADDR)
 ld   de, Level1
 add  hl, de
 ld   (LEVELPT), hl
BuiltInLevels:
 ld   (ORIGLVL), hl
 ld   hl, $0004
 ld   ($800C), hl
 lea(Menu0)
 set  3, (iy+05)
 ROM_CALL(D_ZT_STR)
 CALL_(Copy2Active)
 ld   bc, (PROGRAM_ADDR)
WaitMenu0:
 call GET_KEY
 and  a
 jz   WaitMenu0
#ifndef _LITE
 cp   K_F1
 jz   SetSoundOn
#endif
 cp   K_F2
 jz   SetSoundOff
 cp   K_F3
 jz   Set2Player
 jr   WaitMenu0
#ifndef _LITE
SetSoundOn:
 ld   hl, PlayNote
 add  hl, bc
 ex   de, hl
 jr   SetWhat
#endif
SetSoundOff:
 ld   hl, Nothing
 add  hl, bc
 ex   de, hl
 jr   SetWhat
Set2Player:
 CALL_(GetServer)
 JUMP_NC(Title)
 CALL_(WaitAWhile)
 ld   bc, (PROGRAM_ADDR)
 add  hl, bc
 ex   de, hl
SetWhat:
 res  3, (iy+05)
 ld   hl, DoWhat+1
 add  hl, bc
 ld   (hl), e
 inc  hl
 ld   (hl), d
;Set other vars
 xor  a
 ld   (ZeroByte), a
 ld   (LEVELY), a
 ld   (SCROLLY), a
 ld   (JUMPFLAG), a
 ld   (ANICOUNT), a
 ld   (SPEED), a
 ld   (WHATPLAIN), a
 ld   (ACCEL), a
 ld   (SONGLENG), a
 ld   h, a
 ld   l, a
 ld   (SCORE), hl
 ld   (SCROLLY1), hl
 ld   a, 2
 ld   (WAITORPLAY), a
 ld   a, 6
 ld   (LIFE), a
 ;Draw screen first time:
StartGameLoop:
CBufC2:    call ClearDBuf
DScreenC2: call DrawScreen
 ld   b, 52
 ld   c, 44

St_GameLoop:
 push bc
 ld   hl, (PROGRAM_ADDR)
 ld   de, PJ2Game
 add  hl, de
 ld   bc, 0
 CALL_(DeGCP)

 ld   hl, $0B16
 ld   ($8333), hl
 ld   a, (LIFE)
 add  a, '0'
 ROM_CALL(M_CHARPUT)
 pop  bc

;
;The game loop:
;
GameLoop:
DoWhat: call Nothing
 xor  a
 ld   (HIGHJUMP), a
 ld   a, c
 cp   44
 jr   nz, TestKeys
 push bc
 ld   a, b
 add  a, 8
 ld   b, a
 ld   a, 63
 sub  c
 sub  14
 ld   c, a
 CALL_(TestPixel)
 pop  bc
 and  a
 JUMP_Z(LostLife)
 cp   11b
 jz   TestKeys
 cp   10b
 jnz  TestDarkGray
 ld   a, (ACCEL)
 sub  2
 ld   (ACCEL), a
 and  a
 jz   SlowDown
 cp   250
 jb   TestKeys
SlowDown:
 xor  a
 ld   (ACCEL), a
 ld   a, (SPEED)
 cp   2
 jb   TestKeys
 dec  a
 ld   (SPEED), a
 CALL_(ShowSpeed)
 jmp  TestKeys
TestDarkGray:
 ld   a, 1
 ld   (HIGHJUMP), a
TestKeys:
 ld   a, $3E
 out  (1), a
 in   a, (1)
 and  a
 JUMP_Z(Redraw)
 ld   (KEYPRESS), a
TestLeftKey:
 and  2
 jr   nz, TestRightKey
 ld   a, b
 cp   2
 jb   TestRightKey
 dec  b
 ld   a, (SPEED)
 cp   MAXSPEED-1
 jr   c, TestRightKey
 dec  b
TestRightKey:
 ld   a, (KEYPRESS)
 and  4
 jr   nz, TestUpKey
 ld   a, b
 cp   110
 jae  TestUpKey
 inc  b
 ld   a, (SPEED)
 cp   MAXSPEED-1
 jr   c, TestUpKey
 inc  b
TestUpKey:
 ld   a, (KEYPRESS)
 and  8
 jr   nz, TestDownKey
 ld   a, (SPEED)
 cp   MAXSPEED
 jae  TestDownKey
 ld   a, (ACCEL)
 inc  a
 cmp  6
 jb   SetAccel
 ld   hl, SPEED
 inc  (hl)
 CALL_(ShowSpeed)
 xor  a
SetAccel:
 ld   (ACCEL), a
TestDownKey:
 ld   a, (KEYPRESS)
 and  1
 jr   nz, Test2ndKey
 ld   a, (SPEED)
 and  a
 jr   z, Test2ndKey
 ld   a, (ACCEL)
 inc  a
 inc  a
 cmp  6
 jb   SetAccel_1
 ld   hl, SPEED
 dec  (hl)
 CALL_(ShowSpeed)
 xor  a
SetAccel_1:
 ld   (ACCEL), a
Test2ndKey:     ;JUMP?
 ld   a, (KEYPRESS)
 and  32
 jr   nz, TestExitKey
 ld   a, (JUMPFLAG)
 and  a
 jr   nz, TestExitKey
 ld   a, 1
 ld   (JUMPFLAG), a
 ld   a, (HIGHJUMP)
 and  a
 jnz  Table4
 ld   a, (SPEED)
 cmp  4
 jz   Table3
 cmp  1
 jz   Table2
Table2:
 ld   de, SineTable2
 ld   a, 30
 jr   SetSineTable
Table1:
 ld   de, SineTable1
 ld   a, 21
 jr   SetSineTable
Table3:
 ld   de, SineTable3
 ld   a, 36
 jr   SetSineTable
Table4:
 ld   de, SineTableHg
 ld   a, 45
SetSineTable:
 ld   (NOSINE), a
 ld   hl, (PROGRAM_ADDR)
 add  hl, de
 ld   (SINEPT), hl
TestExitKey:
 ld   a, (KEYPRESS)
 and  64
 JUMP_Z(ExitGame)
TestPauseKey:
 ld   a, (KEYPRESS)
 and  128
 JUMP_Z(Pause)
TestF1Key:
 ld   a, $3F
 out  (1), a
 in   a, (1)
 and  16
 JUMP_Z(LSaveGame)

Redraw:
 ld   a, (JUMPFLAG)
 and  a
 jr   z, ReallyRedraw
 ld   hl, (SINEPT)
 ld   c, (hl)
 inc  hl
 ld   (SINEPT), hl
 ld   a, (NOSINE)
 dec  a
 jnz  SetNoSine
 xor  a
 ld   (JUMPFLAG), a
SetNoSine:
 ld   (NOSINE), a
ReallyRedraw:
 ld   a, (SPEED)
 and  a
 jr   z, RedrawBall
 push bc
 ld   b, a
DoScrolling:
DSclC1: call DoScroll
 djnz DoScrolling
 pop  bc

RedrawBall:
 ld   hl, Bump
 ld   a, (hl)
 and  a
 jz   RedrawBall_1
 ld   d, h
 ld   e, l
 inc  hl
 push bc
 ld   bc, 8
 ldir
 pop  bc
 ld   a, (Bump)
 and  a
 jz   RedrawBall_1
 ld   b, a
 cp   114
 jb   RedrawBall_1
 JUMP_(LostLife)
RedrawBall_1:
;First, redraw the starship
 ld   a, (SS_POSY)
 and  a
 jr   z, NoStarShip
DoSSC1:  call  DoStarShip
 jr   RedrawBall_10
NoStarShip:
 ld   a, r
 cp   25
 jae  RedrawBall_10
;Init starship...
 and  00000111b
 rlca
 rlca
 rlca
 rlca
 ld   hl, SS_POSY
 ld   (hl), 44
 inc  hl
 ld   (hl), a
 inc  hl
 ld   (hl), 0
 inc  hl
 ld   a, (LEVELY)
 add  a, 3
 ld   (hl), a
 CALL_(DoStarShip)
RedrawBall_10:
 ld   ix, (BallPt)
 ld   hl, BallBk
 ld   (SpriteHlp), hl
SGAPC1: call  SpriteGAP

 ld   a, (ANISCROLLC)
 ld   hl, SPEED
 add  a, (hl)
 ld   (ANISCROLLC), a
 cp   6
 jr   c, GoOnMainLoop

 xor  a
 ld   (ANISCROLLC), a
 ld   hl, ANICOUNT
 inc  (hl)
 ld   a, (hl)
 cp   3
 jr   nz, NextFrame
 ld   (hl), 0
 ld   hl, (PROGRAM_ADDR)
 ld   de, Marble0
 add  hl, de
 ld   (BallPt), hl
 jr   GoOnMainLoop
NextFrame:
 ld   hl, (BallPt)
 ld   de, 64
 add  hl, de
 ld   (BallPt), hl

GoOnMainLoop:
C2ActC1: call  Copy2Active
 ld      ix, BallBk
EBkC1:   call  EraseBk
 ld      a, (SS_POSY)
 and     a
ErsSSC1: call  nz, EraseStarShip
 ld      a, (E0_BALLY)
 and     a
J2Loop1: jp    z, GameLoop
 CALL_(EraseLink)
J2Loop:  jp    GameLoop

Pause:
 call GET_KEY
 cp   K_ENTER
 jr   nz, Pause
 JUMP_(GameLoop)

LostLife:
;Go on while ball's falling & screen's fading
 ld   (BALLY), bc
 ld   hl, (LEVELPT)
 ld   (Help), hl
 ld   b, 15
LostLife_Loop:
 push bc
 ld   a, (SPEED)
 and  a
 jr   z, LostLife_L1
 push bc
 ld   b, a
DoScrolling_L:
 CALL_(DoScroll)
 djnz DoScrolling_L
 pop  bc
LostLife_L1:
 ld   bc, (BALLY)
 inc  c
 ld   (BALLY), bc
 ld   ix, (BallPt)
 ld   hl, BallBk
 ld   (SpriteHlp), hl
 CALL_(SpriteGAP)
 CALL_(Copy2Active)
 ld   ix, BallBk
 CALL_(EraseBk)
 pop  bc
 djnz LostLife_Loop
 xor  a
 ld   (Bump),    a
 ld   (SPEED),   a
 ld   (SS_POSY), a
 ld   (SCROLLY), a
 ld   (SCROLLY1), a
 ld   (SCROLLY2), a
 ld   (GameLoad), a
 CALL_(ShowSpeed)
 ld   a, (LIFE)
 dec  a
 jr   z, GameOver
 ld   (LIFE), a
 ld   hl, (Help)
FindStone:
 dec  hl
 dec  hl
 ld   (LEVELPT), hl
 ld   a, (LEVELY)
 dec  a
 ld   (LEVELY), a
 JUMP_Z(FoundDone_End)
 ld   c, 10000000b
 ld   b, 0
FindStone1:
 ld   a, (hl)
 and  c
 jr   nz, FoundDone
 srl  c
 jr   z, FindStone
 ld   a, b
 add  a, 16
 ld   b, a
 jr   FindStone1
FoundDone:
 ld   c, 44
 push bc
DScreenC3: call DrawScreen
 ld   hl, $0B16
 ld   ($8333), hl
 ld   a, (LIFE)
 add  a, '0'
 ROM_CALL(M_CHARPUT)
 ld   b, 32
ForwardScroll:
 CALL_(DoScroll)
 djnz ForwardScroll
 pop  bc
 JUMP_(GameLoop)
FoundDone_End:
 ld   hl, (ORIGLVL)
 inc  hl
 inc  hl
 ld   (LEVELPT), hl
 ld   b, 10
 jr   FoundDone


GameOver:
 ld   a, (E0_BALLY)
 and  a
 jz   GameOver1
 xor  a
 push hl
 CALL_(Send_By)      ;uii! looser!
 pop  hl
GameOver1:
 ld   hl, 0
 ld   (LEVELPT), hl
 ld   a, (CONTRAST)
 out  (2), a
 ROM_CALL(CLEARLCD)
 set  3, (iy+05)
 CALL_(HiScoreHand)
 res  3, (iy+05)
 JUMP_(TitleStart)

LSaveGame:
 ld  (BALLY), bc
 ld  a, (GameLoad)
 and a
 jr  z, LSaveGame1
 ld  hl, (ORIGLVL)
 ld  de, 512
 add hl, de
 jr  LSaveGame2
LSaveGame1:
 ld  hl, (PROGRAM_ADDR)
 ld  de, LevelSaved
 add hl, de
LSaveGame2:
 ld  de, BALLY
 ex  de, hl
 ld  bc, SaveSize
 ldir
 ld  hl, ZS_BITS
 set 1, (hl)              ;Tell ZShell to warp out...
 CALL_(GrayScaleOff)
 ld  a, 0C0h
 out (7), a
 ret

ExitGame:
 ld   a, (CONTRAST)
 out  (2), a
 CALL_(GrayScaleOff)
 ld  a, 0C0h
 out (7), a
 ret

;
;ShowSpeed
;
ShowSpeed:
;First, erase the whole thingy:
 push bc
#ifdef _LITE
 ld   hl, (Page1Addr)
 ld   de, 3
 add  hl, de
 ld   b, 11
 xor  a
 ld   de, 16
ShowSpeed_L:
 ld   (hl), a
 add  hl, de
 djnz ShowSpeed_L
 ld   a, (SPEED)
 and  a
 jr   z, ShowSpeed_D
 ld   b, a
 ld   de, -32
ShowSpeed_L1:
 ld   (hl), 255
 add  hl, de
 djnz ShowSpeed_L1
ShowSpeed_D:
#else
 ld   a, (SPEED)
 ld   b, a
 ld   hl, (PROGRAM_ADDR)
 ld   de, SpeedPics
 add  hl, de
 and  a
 jr   z, NoSpeed_SS
 ld   de, 18
SS_AddLoop:
 add  hl, de
 djnz SS_AddLoop
NoSpeed_SS:

 ld   de, (Page1Addr)
 inc  de
 inc  de
 inc  de

 ld   bc, $0940
SS_ShowBMP:
 ldi
 ldi
 push bc
 ex   de, hl
 ld   bc, 14
 add  hl, bc
 ex   de, hl
 pop  bc
 djnz SS_ShowBMP

 ld   hl, (PROGRAM_ADDR)
 ld   de, SpeedPics+72
 add  hl, de

 ld   de, (Page2Addr)
 inc  de
 inc  de
 inc  de

 ld   bc, $0940
SS_ShowBMP2:
 ldi
 ldi
 push bc
 ex   de, hl
 ld   bc, 14
 add  hl, bc
 ex   de, hl
 pop  bc
 djnz SS_ShowBMP2
#endif
 pop  bc
 ret

;
;Copy2Active
;
Copy2Active
 push bc
 ld   hl, (Page1Addr)
 ld   de, (PageCAddr)
 ld   bc, 1024
 ldir
 ld   hl, (Page2Addr)
 ld   de, (PageDAddr)
 ld   bc, 1024
 ldir
 pop  bc
 ret

;
;ClearDBuf
;
ClearDBuf:
 mov  hl, (Page1Addr)
 mov  d, h
 mov  e, l
 inc  de
 mov  (hl), 0
 mov  bc, 1023
 ldir
 mov  hl, (Page2Addr)
 mov  d, h
 mov  e, l
 inc  de
 mov  (hl), 0
 mov  bc, 1023
 ldir
 ret

;
;WhiteLine: draws a horizontal, white line from (B,D) to (C,D)
;
WhiteLine:
 push hl
 push de
 ld   h, 0
 ld   l, d
 ld   d, h
 MulHL16
 push bc
 shr  b         ;divide b by 8
 shr  b
 shr  b
 mov  e, b
 add  hl, de
 mov  b, h
 mov  c, l
 mov  hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 mov  hl, (Page1Addr)
 add  hl, bc
 pop  bc
;HL & DE now contain video-offset
 ld   a, c
 sub  b
 ld   c, a
 ld   a, b      ;load real x1-pos into a
 and  7         ;and make the mask
 ld   b, 128    ;b is the video-mask
 jz   WLoop     ;mod(a,7) = 0->no mask-shift needed
 push de
 ld   e, 128
 ld   b, a      ;times to shift
ShiftWLoop:
 srl  e
 djnz ShiftWLoop
 ld   b, e
 pop  de
WLoop:          ;ready-go!
 ld   a, b                 ;erase point
 xor  255
 and  (hl)
 ld   (hl), a
 ld   (de), a

 dec  c
 jz   EndWhite

 ror  b
 jnc  WLoop
 inc  hl
 inc  de
 jmp  WLoop
EndWhite:
 pop  de
 pop  hl
 ret

;
;DrwALine: draws a horizontal, line from (B,D) to (C,D) in color A
;
DrwALine:
 push hl
 push de
 ld   h, 0
 ld   l, d
 ld   d, h
 MulHL16
 push bc
 shr  b         ;divide b by 8
 shr  b
 shr  b
 mov  e, b
 add  hl, de
 mov  b, h
 mov  c, l
 mov  hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 mov  hl, (Page1Addr)
 add  hl, bc
 pop  bc
 cp   3
 je   GoOnDrwLine
 cp   2
 jnz  CMP01
 ld   d, h            ;Point both to page #1
 ld   e, l
 jr   GoOnDrwLine
CMP01:
 ld   h, d            ;Both point to page #2
 ld   l, e
GoOnDrwLine:
;HL & DE now contain video-offset
 ld   a, c
 sub  b
 ld   c, a
 ld   a, b      ;load real x1-pos into A
 and  7         ;and make the mask
 and  a
 ld   b, 128    ;B is the video-mask
 jz   BLoop     ;mod(A,7) = 0->no mask-shift needed
 push de
 ld   e, b
 ld   b, a      ;times to shift
ShiftBLoop:
 ror  e
 djnz ShiftBLoop
 ld   b, e
 pop  de
BLoop:          ;ready-go!
 ld   a, (hl)
 or   b
 ld   (hl), a
 ld   a, (de)
 or   b
 ld   (de), a

 dec  c
 jz   EndBlack

 ror  b
 jnc  BLoop
 inc  hl
 inc  de
 jmp  BLoop
EndBlack:
 pop  de
 pop  hl
 ret

;
;DrawLine: this draws a line at y-pos D, according to bits in (IX) & (IX+1)
;
DrawLine:
 push de
 push bc
 ld   hl, (PROGRAM_ADDR)
 ld   bc, StartLine1
 add  hl, bc
 ld   b, 0
 ld   c, d
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 add  hl, bc
 push hl
 push de
 ld   b, (hl)
 ld   de, 8
 add  hl, de
 pop  de
 ld   c, (hl)
WLineC1: call WhiteLine
 pop  hl
;**HL now contains pointer to StartLine1
 ld   e, $80
DrawLineLoop:
 ld   b, (hl)
 inc  hl
 ld   c, (hl)
 ld   a, (ix)
 and  e
 jz   WhiteLn
 ld   a, (ix+1)
 and  e
 jnz  BlackLn
 ld   a, 2
 jr   DrwLinLoop_1
BlackLn:
 ld   a, 3
 jr   DrwLinLoop_1
WhiteLn:
 ld   a, (ix+1)
 and  e
 jz   DrwALineOn
 ld   a, 1
DrwLinLoop_1:
DrwALineC1: call DrwALine
DrwALineOn:
 shr  e
 jnz  DrawLineLoop
 pop  bc
 pop  de
 ret

;
;DrawScreen
;
DrawScreen:
 ld   ix, (LEVELPT)
 ld   b, 31
DrawScrLoop:
 ld   a, b
 add  a, 32
 ld   d, a
DLineC1: call DrawLine
 djnz DrawScrLoop
 ld   ix, (LEVELPT)
 inc  ix
 inc  ix
 ld   b, 21
DrawScrLoop1:
 ld   a, b
 add  a, 11
 ld   d, a
DLineC2: call DrawLine
 djnz DrawScrLoop1
 ld   hl, (LEVELPT)
 inc  hl
 inc  hl
 inc  hl
 inc  hl
 push hl
 pop  ix
 ld   b, 11
DrawScrLoop2:
 ld   d, b
DLineC3: call DrawLine
 djnz DrawScrLoop2
 ret

;
;DoScroll: handles scrolling
;
DoScroll:
 ld   hl, SCROLLY
 inc  (hl)
 ld   a, (hl)
 cp   32                  ;SCROLLY = 32 ?
 jr   nz, LoadHLScr
 xor  a
 ld   (hl), a
 ld   d, a
 ld   h, a
 ld   l, a
 ld   (SCROLLY1), hl
 ld   ($8333), hl
 ld   hl, (SCORE)
 CALL_(HL_DECIMAL_MENU)
 ld   a, (LEVELY)    ;increment LEVELY
 inc  a
 cp   128
 jr   z, Bonus
 cp   251
 jr   nz, NoBonus
Bonus:
 ld   hl, $0B16
 ld   ($8333), hl
 ld   hl, LIFE
 inc  (hl)
 push af
 ld   a, (hl)
 add  a, '0'
 ROM_CALL(M_CHARPUT)
 pop  af
NoBonus:
 ld   (LEVELY), a
 cp   253
 jr   nz, GoOnScroll
 xor  a
 ld   (LEVELY), a
 ld   hl, (ORIGLVL)
 ld   (LEVELPT), hl
GoOnScroll:
 ld   hl, (SCORE)
 ld   d, 0
 ld   a, (SPEED)
 ld   e, a
 add  hl, de
 ld   (SCORE), hl
 ld   hl, (LEVELPT)  ;and increment LEVELPT
 inc  hl
 inc  hl
 ld   (LEVELPT), hl
LoadHLScr:
 ld   a, (WHATPLAIN)
 inc  a
 cmp  4
 jnz  WhatPlain_Set
 ld   a, 1
WhatPlain_Set:
 ld   (WHATPLAIN), a
 cmp  2
 jz   Plain_2
 cmp  3
 jz   Plain_3
Plain_1:
 ld   a, (SCROLLY1)
 inc  a
 ld   (SCROLLY1), a
 ld   d, a
 ld   hl, (LEVELPT)  ;get Levelinformation from LEVELPT
 inc  hl
 inc  hl
 inc  hl
 inc  hl
 push hl
 pop  ix
DLineC5: call DrawLine
Plain_2:
 ld   a, (SCROLLY2)
 inc  a
 ld   (SCROLLY2), a
 add  a, 10
 ld   d, a
 ld   ix, (LEVELPT)
 inc  ix
 inc  ix
DLineC6: call DrawLine
Plain_3:
 ld   a, (SCROLLY)
 add  a, 32
 ld   d, a
 ld   ix, (LEVELPT)
DLineC7: call DrawLine
 ret

;
;SpriteGAP: get bk to (SpriteHlp) and then puts sprite IX at (B,C)
;
SpriteGAP:
 mov  a, b
 cmp  129-16
 jb   SpriteGAP_Start
 ret
SpriteGAP_Start:
 push bc
 mov  hl, (SpriteHlp)
 mov  (SpriteHlp1), ix
 ld   a, c
 cp   47
 mov  a, 32
 jb   SpriteGAP_Start1
 push bc
 ld   a, c
 sub  48
 ld   c, a
 sla  c
 ld   a, 32
 sub  c
 pop  bc
SpriteGAP_Start1:
 mov  (SprLine), a
 mov  h, 0
 mov  l, c
 mov  d, h
 MulHL16
 push bc
 shr  b
 shr  b
 shr  b
 mov  e, b
 add  hl, de
 mov  b, h
 mov  c, l
 mov  hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 mov  hl, (Page1Addr)
 add  hl, bc
 pop  bc
 mov  a, b
;**And now start:
 mov  bc, 16
 mov  b, 128
 mov  c, b
 and  7
 jz   SpriteGAP_B
 mov  b, a
SpriteGAP_S:
 shr  c
 loop SpriteGAP_S
 mov  b, 128
SpriteGAP_B:
 mov  ix, (SpriteHlp)
 mov  a, (hl)                         ;first, save background
 and  c
 jz   SG_CheckPage2
 mov  a, (ix)
 or   b
 mov  (ix), a
SG_CheckPage2:
 mov  a, (de)
 and  c
 jz   SG_Draw
 mov  a, (ix+32)
 or   b
 mov  (ix+32), a
SG_Draw:
 mov  ix, (SpriteHlp1)              ;now, start!
 mov  a, (ix)                       ;is point 1(black -> check is invisible)
 and  b
 jnz  SG_Point0
 mov  a, c                          ;erase point 1
 xor  255
 and  (hl)
 mov  (hl), a
 mov  a, (ix+32)                    ;what's about point 2?
 and  b
 jnz  SG_Point01
 ex   de, hl                        ;white, too
 mov  a, c
 xor  255
 and  (hl)
 mov  (hl), a
 ex   de, hl
 jmp  SG_Loop
SG_Point0:
 mov  a, (ix+32)
 and  b
 jnz  SG_Loop
 mov  a, (hl)
 or   c
 mov  (hl), a
 ex   de, hl
 mov  a, c
 xor  255
 and  (hl)
 mov  (hl), a
 ex   de, hl
 jmp  SG_Loop
SG_Point01:
 mov  a, (de)
 or   c
 mov  (de), a
SG_Loop:
 ror  c
 jnc  SG_RorB
 inc  hl
 inc  de
SG_RorB:
 ror  b
 jnc  SpriteGAP_B
 mov  a, (SprLine)
 dec  a
 mov  (SprLine), a
 jz   SG_End
 inc  ix
 mov  (SpriteHlp1), ix
 push bc
 mov  bc, (SpriteHlp)
 inc  bc
 mov  (SpriteHlp), bc
 pop  bc
 and  1
 JUMP_NZ(SpriteGAP_B)
 push bc
 mov  bc, 14
 add  hl, bc
 ex   de, hl
 add  hl, bc
 ex   de, hl
 pop  bc
 JUMP_(SpriteGAP_B)
SG_End:
 pop  bc
 ret

;
;EraseBk: erases the background IX at (B,C)
;
EraseBk:
 mov  a, b
 cmp  129-16
 jb   EraseBk_Start
 ret
EraseBk_Start:
 push bc
 push de
 ld   a, c
 cp   47
 mov  a, 32
 jb   EraseBk_Start1
 push bc
 ld   a, c
 sub  48
 ld   c, a
 sla  c
 ld   a, 32
 sub  c
 pop  bc
EraseBk_Start1:
 mov  (SprLine), a
 mov  h, 0
 mov  d, h
 mov  l, c
 MulHL16
 push bc
 shr  b
 shr  b
 shr  b
 mov  e, b
 add  hl, de
 mov  b, h
 mov  c, l
 mov  hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 mov  hl, (Page1Addr)
 add  hl, bc
 pop  bc
 mov  a, b
 mov  b, 128
 mov  c, b
 and  7
 jz   EraseBk_B
 mov  b, a
EraseBk_S:
 shr  c
 loop EraseBk_S
 mov  b, 128
EraseBk_B:
 mov  a, (ix)
 and  b
 jz   EB_Point0
 mov  a, (hl)
 or   c
 mov  (hl), a
 jmp  EB_Check2
EB_Point0:
 mov  a, c
 xor  255
 and  (hl)
 mov  (hl), a
EB_Check2:
 mov  a, (ix+32)
 and  b
 jz   EB_Point01
 mov  a, (de)
 or   c
 mov  (de), a
 jmp  EB_Loop
EB_Point01:
 ex   de, hl
 mov  a, c
 xor  255
 and  (hl)
 mov  (hl), a
 ex   de, hl
EB_Loop:
 ror  c
 jnc  EB_RorB
 inc  hl
 inc  de
EB_RorB:
 ror  b
 jnc  EraseBk_B
 xor  a
 mov  (ix), a
 mov  (ix+32), a
 inc  ix
 mov  a, (SprLine)
 dec  a
 mov  (SprLine), a
 jz   EB_End
 and  1
 jnz  EraseBk_B
 push bc
 mov  bc, 14
 add  hl, bc
 ex   de, hl
 add  hl, bc
 ex   de, hl
 pop  bc
 jmp  EraseBk_B
EB_End:
 pop  de
 pop  bc
 ret

;
;Delay: waits
;
Delay:
 push af
 push bc
 ld bc, $1000
DelayLoop:
 dec bc
 ld a, b
 or c
 jr nz, DelayLoop
 pop bc
 pop af
 ret

;
;Testpixel : returns A = 0 if pixel white
;
TestPixel:
 push bc
 ROM_CALL(FIND_PIXEL)
 push hl
 push af
 ld   de, (Page1Addr)
 add  hl, de
 and  (hl)
 ld   e, 0
 jz   TestPage2
 ld   e, 1
TestPage2:
 pop  af
 pop  hl
 push de
 ld   de, (Page2Addr)
 add  hl, de
 pop  de
 and  (hl)
 jz   SetPage2_0
 ld   a, e
 or   10b
 pop  bc
 ret
SetPage2_0:
 ld   a, e
 pop  bc
 ret

;
;HL_DECIMAL_MENU(Magnus Hagander):Writes the in HL stored word in menu font
;
HL_DECIMAL_MENU:
 push bc
 push de
 ld   de, StringPlace+4
 ld   b,  5
ConvLoop:
 call UNPACK_HL
 add  a,'0'
 ld   (de), a
 dec  de
 djnz ConvLoop
 ld   hl, StringPlace
 ROM_CALL(D_ZM_STR)
 pop de
 pop bc
 ret

;
;SpecialShow
;
#ifndef _LITE
SpecialShow:
 mov  b, 32
 mov  de, 0
SpecialShow_L1:
 push bc
 push de
 mov  hl, (PageCAddr)
 add  hl, de
 push hl
 mov  hl, (Page1Addr)
 add  hl, de
 pop  de
 mov  bc, 16
 ldir
 pop  de
 push de
 mov  hl, (PageDAddr)
 add  hl, de
 push hl
 mov  hl, (Page2Addr)
 add  hl, de
 pop  de
 mov  bc, 16
 ldir
 pop  de
 pop  bc
 CALL_(Delay)
 CALL_(Delay)
 ex   de, hl
 mov  de, 32
 add  hl, de
 ex   de, hl
 loop SpecialShow_L1
 mov  b, 32
 mov  de, 1008
SpecialShow_L2:
 push bc
 push de
 mov  hl, (PageCAddr)
 add  hl, de
 push hl
 mov  hl, (Page1Addr)
 add  hl, de
 pop  de
 mov  bc, 16
 ldir
 pop  de
 push de
 mov  hl, (PageDAddr)
 add  hl, de
 push hl
 mov  hl, (Page2Addr)
 add  hl, de
 pop  de
 mov  bc, 16
 ldir
 pop  de
 pop  bc
 CALL_(Delay)
 CALL_(Delay)
 ex   de, hl
 mov  de, -32
 add  hl, de
 ex   de, hl
 loop SpecialShow_L2
 ret
#endif

;
;Adjust
;
Adjust:
 push bc
 ld   c, (hl)
 inc  hl
 ld   b, (hl)
 inc  hl
 inc  hl
 ld   e, (hl)
 ld   a, (LEVELY)
 cp   e
 jr   z, Adjust_SameHeight
 sub  e
 cp   255
 jr   z, Adjust_OneForward
 cp   254
 jr   nz, Adjust_Exit
 srl  b
 srl  b
 ld   a, 40
 add  a, b
 ld   b, a
 ld   c, 0
 ld   de, 64
 add  ix, de
 jr   Adjust_Show
Adjust_OneForward:
 srl  b
 ld   a, 23
 add  a, b
 ld   b, a
 ld   c, 16
 ld   de, 128
 add  ix, de
Adjust_SameHeight:
Adjust_Show:
 CALL_(SpriteGAP)
Adjust_Exit:
 pop  bc
 ret

;
;AdjustErase
;
AdjustErase:
 push bc
 ld   c, (hl)
 inc  hl
 ld   b, (hl)
 inc  hl
 inc  hl
 ld   e, (hl)
 ld   a, (LEVELY)
 cp   e
 jr   z, AdjustE_SameHeight
 sub  e
 cp   255
 jr   z, AdjustE_OneForward
 cp   254
 jr   nz, AdjustE_Exit
 srl  b
 srl  b
 ld   a, 40
 add  a, b
 ld   b, a
 ld   c, 0
 jr   AdjustE_Show
AdjustE_OneForward:
 srl  b
 ld   a, 23
 add  a, b
 ld   b, a
 ld   c, 16
AdjustE_SameHeight:
AdjustE_Show:
 CALL_(EraseBk)
AdjustE_Exit:
 pop  bc
 ret


;
;A bigger delay
;
#ifndef _LITE
WaitAWhile:
 mov  b, 50
WWDelayLoop:
 CALL_(Delay)
 loop WWDelayLoop
Wait_End
 ret
#endif

;
;GetServer
;
GetServer:
 in a,($07)              ; Read the link port
 and $03                 ; Mask off bits 0 and 1
 cp  $01                 ; Check if it is a W
 jr nz,SendOutPulse      ; If it isn't then this calc is the server
			 ; jump to server negotiation routine
 ld  a,$D4               ; Send an R in confirmation
 out ($07),a             ; Write the reg a to the port
;Set this calc to client:
 ld  hl, Client
LinkNegoWaitR:           ; * Wait for the W to be reset by the
			 ; server
 in a,($07)              ; read the port
 and 3                   ; MASK off bits 0 and 1
 cp $02                  ; IS R and only R pulled?
 jr z,NegoClearLink      ; Clear the link (send a $C0 to port7)
 jr LinkNegoWaitR        ; If W is still on go back to the beginning
				; and run (loop)
SendOutPulse:                   ; * Send out a pulse as the server
 ld   hl,(PROGRAM_ADDR)  ; load hl with the address of the program
 ld   de,WaitingStr      ; load de with the address of the string
 add  hl,de              ; Calculate the address (add the two together)
 ROM_CALL(D_ZT_STR)      ; Display the text
 CALL_(Copy2Active)
 ld   a,$E8              ; PULL W to Ground
 out  ($07), a           ; send it
WaitPulse:                      ; * Wait for response *
 in  a,($07)             ; Read port
 and $03                 ; mask off bits 0 and 1
 cp  $00
 jr  z,WaitPulseDone     ; if they are go to next step
 call GET_KEY            ; get a key press
 cp  K_EXIT              ; is it the exit key
 jr  nz,WaitPulse        ; if not jup to waitpulse
 ld  a,$C0               ; if it is clear the link
 out ($07),a             ; actually do it
 or  a
 ret                     ; return to Zshell
WaitPulseDone:
;this calc is the server:
 ld  hl, Server
NegoClearLink:
 ld  a,$C0               ; Clear the link
 out ($07),a             ; send the clear
 scf
 ret

;
;Client:
;
Server:
 push bc
;Now, receive data:
 ld   hl, E0_BALLY
RB0: call Rece_By
 and  a
 JUMP_Z(Winner)
 ld   (hl), a
 inc  hl
RB1: call Rece_By
 ld   (hl), a
 inc  hl
RB2: call Rece_By
 ld   (hl), a
 inc  hl
RB3: call Rece_By
 ld   (hl), a
;Send position:
 ld   hl, BALLY
 ld   a, (hl)
 inc  hl
SB0: call Send_By
 ld   a, (hl)
SB1: call Send_By
 inc  hl
 ld   a, (hl)
SB6: call Send_By
 inc  hl
 ld   a, (hl)
SB7: call Send_By
;Now, show enemy:
 ld   hl, EnemBk
 ld   (SpriteHlp), hl
ImgL0: ld  ix, EMarble0
 ld   hl, E0_BALLY
AdC0: call Adjust
 pop  bc
 ret

;
;Server:
;
Client:
;Now, send data:
 push bc
 ld   hl, BALLY
 ld   a, (hl)
 inc  hl
SB2: call Send_By
 ld   a, (hl)
 inc  hl
SB3: call Send_By
 ld   a, (hl)
 inc  hl
SB4: call Send_By
 ld   a, (hl)
 inc  hl
SB5: call Send_By
Client_GoOn:
;Receive enem position:
 ld   hl, E0_BALLY
RB4: call Rece_By
 and  a
 JUMP_Z(Winner)
 ld   (hl), a
 inc  hl
RB5: call Rece_By
 ld   (hl), a
 inc  hl
RB6: call Rece_By
 ld   (hl), a
 inc  hl
RB7: call Rece_By
 ld   (hl), a
;Now, show enemy:
 ld   hl, EnemBk
 ld   (SpriteHlp), hl
ImgL1: ld  ix, EMarble0
 ld   hl, E0_BALLY
AdC1: call Adjust
 pop  bc
 ret

;
;EraseLink
;
EraseLink:
 push bc
 ld   hl, E0_BALLY
 ld   ix, EnemBk
AdEC1: call AdjustErase
 ld   hl, (E0_BALLY)
 pop  bc
 ld   a, (LEVELY)
 ld   d, a
 ld   a, (E0_LEVELY)
 cp   d
 ret  nz
 CALL_(BitmapInter)
 ret

;
;ShowStarShip
;
DoStarShip:
 push bc
 ld    hl, StarBk
 ld    (SpriteHlp), hl
SSL1:  ld  ix, StarShip0
 ld    hl, SS_POSY
AdC2:  call Adjust
 pop   bc
 ret

;
;EraseStarShip
;
EraseStarShip:
 ld    (BALLY), bc
 push  bc
 ld    ix, StarBk
 ld    hl,  SS_POSY
AdCE1: call AdjustErase
 ld    a, (SS_SCRLY)
 inc   a
 cp    31
 jb    GoOn_SS
 ld    hl, SS_LEVELY
 dec   (hl)
 ld    a, (LEVELY)
 sub   (hl)
 cp    10
 jb    GoOn_SS0
 and   a
 jz    GoOn_SS0
 xor   a
 ld    (SS_POSY), a
 pop   bc
 ret
GoOn_SS0:
 xor   a
GoOn_SS:
 ld    (SS_SCRLY), a
 ld    hl, (SS_POSY)
 ld    a, (BALLX)
 cp    h
 jb    DecSS
 inc   h
 jr    GoOn_SS1
DecSS:
 dec   h
GoOn_SS1:
 ld    (SS_POSY), hl
 pop   bc
 ld    a, (LEVELY)
 ld    d, a
 ld    a, (SS_LEVELY)
 cp    d
 ret   nz
 CALL_(BitmapInter)
 ret

MemError:
 ROM_CALL(CLEARLCD)
 ld  hl, 0
 ld  ($800C), hl
 ld  hl, MemErrStr
 CALL_(MesgWait)
 ret

MemErrStr:
 .db "NEED 3K FREE MEM!",0

;
;BitmapInter
;
BitmapInter:
 ld    a, b     ;compute absolute amount of overlap
 sub   h
 bit   7, a
 jr    z, GoOnTesting
 neg
GoOnTesting:
 cp    16               ;test X-Overlap
 jr    nc, NoColl1
 ;X-Test succeeded, but what about Y?
 ld    a, c
 sub   l
 bit   7, a
 jr    z, GoOnTesting1
 neg
GoOnTesting1:
 cp    16
 jr    nc, NoColl1
 ld    a, 8
 ld    (Bump), a
 push  bc
 ld    a, h
 cp    b
 jae   Inter_Left
 ld    c, 1
 jr    StoreSineBump
Inter_Left:
 ld    c, 255
 jr    StoreSineBump
NoColl1:
 or    a        ;clear carry flag
 ret
StoreSineBump:
 ld    hl, Bump
 ld    a, b
 add   a, c
 add   a, c
 add   a, c
 ld    (hl), a          ;Bump -  1
 inc   hl
 add   a, c
 add   a, c
 ld    (hl), a          ;Bump1 - 2
 inc   hl
 add   a, c
 add   a, c
 ld    (hl), a          ;Bump2 - 3
 inc   hl
 add   a, c
 add   a, c
 ld    (hl), a          ;Bump3 - 4
 inc   hl
 add   a, c
 ld    (hl), a          ;Bump4 - 5
 inc   hl
 add   a, c
 ld    (hl), a          ;Bump5 - 6
 inc   hl
 add   a, c
 ld    (hl), a          ;Bump6 - 7
 inc   hl
 ld    (hl), 0          ;BumpEnd - 8
 pop   bc
 ret

;
;MesgWait:
;
MesgWait:
 ld   de, (PROGRAM_ADDR)
 add  hl, de
 ROM_CALL(D_ZT_STR)
MesgWaitKey:
 call GET_KEY
 cp   K_ENTER
 jr   nz, MesgWaitKey
Nothing:
 ret

;
;LinkError:
;
LinkError:
 pop hl     ;pop PC of Send/Recv
 pop hl     ;pop HL of Client/Server
 pop hl     ;pop PC of  - " -
 ld  de, LinkTxt
LinkErrorShow:
 ld  hl, 0
 ld  ($800C), hl
 ld  hl, (PROGRAM_ADDR)
 add hl, de
 ROM_CALL(D_ZT_STR)
 CALL_(Copy2Active)
 CALL_(MesgWaitKey)
 ld  a, $C0
 out (7), a
JumpToThaTitle:
 JUMP_(TitleStart)
 ret


;
;Winner:
;
Winner:
 pop    hl
 ld     hl, 0
 ld     ($800C), hl
 ld     hl, (PROGRAM_ADDR)
 ld     de, WinnerT
 add    hl, de
 ROM_CALL(D_ZT_STR)
 CALL_(Copy2Active)
 CALL_(MesgWaitKey)
 jr     JumpToThaTitle

;
;Some important variables:
;
Menu:      .db " [F1] New game       "
	   .db " [F2] Restore game   "
	   .db " [F3] Load level     ",0
#ifndef _LITE
Menu0:     .db " [F1] 1 player w/snd "
	   .db " [F2] 1 player no snd"
	   .db " [F3] 2 player RACE! ",0
#else
Menu0:     .db " [F2] 1 player no snd"
	   .db " [F3] 2 player RACE!",0
#endif
#ifdef _LITE
TitleText: .db "PLAIN JUMP ][    "
	   .db " 1996 by Andreas Ess",0
#endif
WaitingStr: .db "Waiting...",0
NoSave:    .db "NO SAVED GAME!",0
LoadError: .db "NO FILE/EXIT PRESSED!",0
LinkTxt:   .db "TRANSMISSION ERROR!",0
WinnerT:   .db "You",39,"re tha winner!!!",0
H_Score:   .dw 300, 200, 100
H_Name:    .db "PJ ][  ",0
	   .db "(C)1996",0
	   .db "BY AE  ",0
H_Title:   .db "TOP 3 MARBLES",0
	       ;123456789012345678901

;-------------------------------------------------------------------------------
;This array contains start&end-line indexes(?)
;-------------------------------------------------------------------------------
StartLine1:
 .db  47, 51, 55, 59, 63, 67, 71, 75, 79
 .db  46, 50, 55, 59, 63, 67, 71, 76, 80
 .db  46, 50, 54, 59, 63, 67, 72, 76, 81
 .db  45, 49, 54, 58, 63, 68, 72, 77, 81
 .db  44, 49, 53, 58, 63, 68, 73, 77, 82
 .db  43, 48, 53, 58, 63, 68, 73, 78, 83
 .db  43, 48, 53, 58, 63, 68, 73, 78, 84
 .db  42, 47, 52, 58, 63, 68, 74, 79, 84
 .db  41, 46, 52, 57, 63, 69, 74, 80, 85
 .db  40, 46, 52, 57, 63, 69, 74, 80, 86
 .db  40, 45, 51, 57, 63, 69, 75, 81, 87
 .db  39, 45, 51, 57, 63, 69, 75, 81, 87
 .db  38, 44, 50, 57, 63, 69, 76, 82, 88
 .db  37, 44, 50, 57, 63, 69, 76, 82, 89
 .db  37, 43, 50, 56, 63, 70, 76, 83, 90
 .db  36, 42, 49, 56, 63, 70, 77, 84, 90
 .db  35, 42, 49, 56, 63, 70, 77, 84, 91
 .db  34, 41, 49, 56, 63, 70, 77, 85, 92
 .db  34, 41, 48, 56, 63, 70, 78, 85, 93
 .db  33, 40, 48, 55, 63, 71, 78, 86, 93
 .db  32, 40, 47, 55, 63, 71, 79, 86, 94
 .db  31, 39, 47, 55, 63, 71, 79, 87, 95
 .db  31, 38, 47, 55, 63, 71, 79, 88, 96
 .db  30, 38, 46, 55, 63, 71, 80, 88, 97
 .db  29, 37, 46, 54, 63, 72, 80, 89, 97
 .db  28, 37, 45, 54, 63, 72, 81, 89, 98
 .db  28, 36, 45, 54, 63, 72, 81, 90, 99
 .db  27, 36, 45, 54, 63, 72, 81, 90, 100
 .db  26, 35, 44, 54, 63, 72, 82, 91, 100
 .db  25, 34, 44, 53, 63, 73, 82, 92, 101
 .db  25, 34, 44, 53, 63, 73, 82, 92, 102
 .db  24, 33, 43, 53, 63, 73, 83, 93, 103
 .db  23, 33, 43, 53, 63, 73, 83, 93, 103
 .db  22, 32, 42, 53, 63, 73, 84, 94, 104
 .db  22, 32, 42, 53, 63, 73, 84, 94, 105
 .db  21, 31, 42, 52, 63, 74, 84, 95, 106
 .db  20, 30, 41, 52, 63, 74, 85, 96, 106
 .db  19, 30, 41, 52, 63, 74, 85, 96, 107
 .db  19, 29, 41, 52, 63, 74, 85, 97, 108
 .db  18, 29, 40, 52, 63, 74, 86, 97, 109
 .db  17, 28, 40, 51, 63, 75, 86, 98, 109
 .db  16, 28, 39, 51, 63, 75, 87, 98, 110
 .db  16, 27, 39, 51, 63, 75, 87, 99, 111
 .db  15, 26, 39, 51, 63, 75, 87, 100, 112
 .db  14, 26, 38, 51, 63, 75, 88, 100, 113
 .db  13, 25, 38, 50, 63, 76, 88, 101, 113
 .db  13, 25, 37, 50, 63, 76, 89, 101, 114
 .db  12, 24, 37, 50, 63, 76, 89, 102, 115
 .db  11, 24, 37, 50, 63, 76, 89, 102, 116
 .db  10, 23, 36, 50, 63, 76, 90, 103, 116
 .db  10, 22, 36, 49, 63, 77, 90, 104, 117
 .db   9, 22, 36, 49, 63, 77, 90, 104, 118
 .db   8, 21, 35, 49, 63, 77, 91, 105, 119
 .db   7, 21, 35, 49, 63, 77, 91, 105, 119
 .db   7, 20, 34, 49, 63, 77, 92, 106, 120
 .db   6, 20, 34, 49, 63, 77, 92, 106, 121
 .db   5, 19, 34, 48, 63, 78, 92, 107, 122
 .db   4, 18, 33, 48, 63, 78, 93, 108, 122
 .db   4, 18, 33, 48, 63, 78, 93, 108, 123
 .db   3, 17, 33, 48, 63, 78, 93, 109, 124
 .db   2, 17, 32, 48, 63, 78, 94, 109, 125
 .db   1, 16, 32, 47, 63, 79, 94, 110, 125
 .db   1, 16, 31, 47, 63, 79, 95, 110, 126
 .db   0, 15, 31, 47, 63, 79, 95, 111, 127

SineTableHg: ;for jumps
 .db 44,42,40,38,36,34,31,29,28,26,24,22
 .db 21,19,18,17,16,15,14,13,13,13,13,13
 .db 13,13,13,14,15,16,17,18,19,21,22,24
 .db 26,28,29,31,34,36,38,41,44

SineTable3:
 .db 44,42,39,37,35,32,30,28,26,24,22,21
 .db 19,18,17,16,16,16,16,16,16,16,17,18
 .db 19,21,22,24,26,28,30,32,35,37,40,44

SineTable2:
 .db 44,42,40,38,36,35,33,31,30,28,27,26
 .db 25,25,25,25,25,25,25,26,27,28,30,31
 .db 33,34,36,38,41,44

SineTable1:
 .db 44,43,41,40,39,37,36,36,35,35,35,35
 .db 35,36,36,37,39,40,41,43,44

;
;ASCII table for input
;
ASCII_Table:                   ;Thanks to Magnus H. for this Table!!!
  .db 0,0,0,0,0,0,0,0,0       ;00-09 - not valid
  .db 'X,'T','O','J','E'      ;0A-0E - valid
  .db 0,0                     ;0F-10 - not valid
  .db ' ','W','S','N','I'     ;11-15 - valid
  .db 'D'                     ;16    - valid
  .db 0,0                     ;17-18 - not valid
  .db 'Z','V','R','M','H','C' ;19-1E- valid
  .db 0,0                     ;1F-20 - not valid
  .db 'Y','U','Q','L','G','B' ;21-26 - valid
  .db 0,0,0,0                 ;27-2A - not valid
  .db 'P','K','F','A'         ;2B-2E - valid
  .db 0,0,0,0,0,0,0,0,0,0,0   ;Rest  - not valid

;
;This is the built-in level:
;
#include pj2lvl.h

;
;Bitmapdata:
;
Marble0:
 .db $FE,$0F,$F0,$7F,$C0,$8F,$F3,$07,$80,$1F,$80,$1F,$00,$1F,$00,$1F
 .db $40,$17,$00,$3F,$80,$7F,$80,$7F,$C0,$7F,$F0,$7F,$F4,$7F,$FF,$FF
 .db $FD,$7F,$FC,$97,$C1,$71,$DC,$BB,$81,$A0,$80,$20,$00,$20,$43,$20
 .db $00,$6C,$40,$44,$C0,$8D,$E0,$CD,$F7,$A1,$EF,$B3,$FB,$8F,$FC,$1F

Marble1:
 .db $F8,$1F,$F0,$FF,$E2,$07,$C4,$07,$84,$07,$40,$03,$40,$01,$40,$07
 .db $03,$07,$01,$01,$A6,$03,$80,$07,$C7,$0F,$F0,$FF,$F0,$0F,$FF,$FF
 .db $F8,$EF,$F1,$0F,$E1,$3B,$C0,$1B,$82,$38,$04,$1C,$44,$0E,$06,$08
 .db $00,$08,$01,$0E,$84,$1D,$A8,$3A,$F2,$35,$E5,$73,$F8,$F7,$FC,$7F

Marble2:
 .db $F8,$FF,$E0,$0F,$C0,$1F,$80,$1F,$82,$17,$39,$FF,$04,$1F,$00,$07
 .db $00,$01,$00,$1F,$00,$FF,$03,$7F,$83,$FF,$CF,$FF,$E7,$FF,$FA,$FF
 .db $FF,$0F,$F8,$73,$C0,$09,$C0,$01,$C4,$2B,$02,$E0,$03,$E0,$87,$F8
 .db $80,$3E,$80,$61,$41,$00,$98,$89,$FD,$01,$D0,$77,$F0,$3F,$FF,$FF


EMarble0:
 .db $FC,$1F,$F8,$0F,$F8,$0F,$F0,$03,$F0,$03,$F0,$03,$F2,$03,$F8,$07
 .db $F8,$03,$F8,$23,$FC,$47,$FC,$03,$FE,$07,$FF,$8F,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$8F,$F7,$87,$EF,$0F,$EF,$13,$EF,$83,$ED,$8B,$E7,$83
 .db $E7,$EF,$E7,$DF,$E3,$BB,$E3,$FF,$F1,$FF,$F8,$7F,$FC,$1F,$FF,$FF

EMarble1:
 .db $F3,$FF,$E3,$FF,$E1,$FF,$F1,$FF,$E1,$FF,$E1,$FF,$FB,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $EF,$FF,$DD,$FF,$D9,$FF,$CF,$FF,$DF,$FF,$DF,$FF,$E5,$FF,$F3,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

EMarble2:
 .db $F3,$FF,$E3,$FF,$E1,$FF,$F1,$FF,$E1,$FF,$E1,$FF,$FB,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $EF,$FF,$DD,$FF,$D9,$FF,$CF,$FF,$DF,$FF,$DF,$FF,$E5,$FF,$F3,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

StarShip0: ;16*16
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$3F,$FC,$1F,$F8,$0F,$F8,$0F
 .db $B9,$C6,$B9,$CE,$BC,$DE,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$BF,$FF,$3F,$FF,$FF,$FF,$F7
 .db $F6,$3F,$E6,$33,$FB,$27,$F8,$0F,$FE,$1F,$FF,$FF,$FF,$FF,$FF,$FF

StarShip1: ;8*8
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$E7,$FF,$62,$FF,$66,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$F7,$FF,$DF,$FF,$99,$FF,$C3,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

StarShip2: ;12*12
 .db $FF,$FF,$FF,$FF,$FF,$FF,$F9,$FF,$F0,$7F,$F0,$7F,$F6,$6F,$BA,$EF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FB,$FF,$FD,$FF,$FF,$BF,$89,$BF,$F5,$3F
 .db $F0,$7F,$F8,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

HiScrScreen:
#ifndef _LITE
TitlePicture:
 .db $67,$28,$AB,$7F,$77,$A9,$28,$7F,$75,$29,$AF,$71,$5C,$65,$5C,$7F,$67
 .db $29,$AF,$76,$52,$6F,$96,$4F,$7F,$6C,$29,$AF,$79,$4C,$72,$23,$4C,$7F
 .db $6F,$24,$A5,$23,$BA,$45,$6A,$44,$66,$50,$63,$45,$65,$24,$4B,$BA,$43
 .db $BA,$AB,$67,$44,$BA,$47,$6C,$25,$A5,$96,$B9,$24,$AF,$68,$23,$AF,$64
 .db $4A,$25,$AB,$B9,$96,$65,$A9,$9A,$49,$B5,$23,$B5,$9A,$66,$A9,$9B,$A5
 .db $25,$AB,$6A,$24,$A9,$23,$AE,$25,$AF,$68,$23,$AF,$64,$4A,$26,$AF,$A5
 .db $9B,$66,$A6,$4A,$B9,$23,$A5,$96,$66,$A9,$9B,$A5,$26,$AB,$69,$24,$A5
 .db $24,$B5,$24,$AF,$67,$A5,$9A,$65,$4A,$26,$AB,$A5,$9B,$66,$A6,$4A,$B9
 .db $23,$A9,$23,$AF,$BE,$A5,$9B,$A5,$27,$AF,$68,$24,$B5,$24,$A5,$24,$AF
 .db $67,$A5,$96,$64,$4B,$27,$AE,$23,$AF,$65,$A6,$4A,$B9,$23,$A9,$23,$AF
 .db $BE,$A5,$97,$A5,$96,$25,$AF,$66,$25,$B5,$24,$A5,$24,$6A,$25,$AF,$BE
 .db $4A,$28,$A9,$96,$67,$A6,$4A,$B9,$23,$A9,$24,$AF,$B9,$24,$AD,$23,$A5
 .db $25,$67,$24,$AD,$24,$A9,$24,$AF,$68,$25,$65,$4B,$28,$A9,$96,$67,$A6
 .db $49,$9E,$25,$A5,$24,$63,$A5,$23,$AE,$23,$A9,$25,$67,$24,$AD,$24,$A5
 .db $24,$AF,$66,$A9,$24,$AF,$BE,$4A,$28,$A9,$96,$67,$A6,$49,$9E,$25,$A5
 .db $24,$AF,$A5,$23,$AE,$23,$A9,$25,$67,$24,$BD,$24,$A5,$24,$AF,$66,$A5
 .db $25,$64,$4B,$29,$A5,$9B,$66,$A6,$49,$9E,$25,$B5,$24,$44,$26,$B9,$23
 .db $A5,$24,$66,$25,$B9,$24,$A5,$24,$AF,$66,$28,$64,$4B,$2D,$AF,$65,$A6
 .db $49,$9B,$25,$A5,$25,$A9,$26,$AD,$23,$A5,$25,$65,$24,$AE,$24,$A9,$25
 .db $68,$A5,$25,$AF,$BD,$4A,$2D,$AF,$65,$A6,$49,$9B,$25,$A9,$26,$A5,$25
 .db $AD,$23,$A9,$25,$65,$24,$AD,$23,$43,$25,$AF,$65,$A5,$27,$64,$9A,$48
 .db $2D,$AF,$65,$A6,$49,$9B,$25,$A9,$26,$B5,$25,$AD,$23,$A9,$25,$64,$04
 .db $9A,$24,$BD,$25,$AF,$65,$A5,$27,$64,$9A,$47,$2E,$49,$9A,$48,$9B,$25
 .db $A9,$26,$A5,$25,$AE,$23,$A9,$26,$63,$04,$99,$03,$AF,$26,$AF,$65,$A5
 .db $27,$AF,$B6,$48,$2E,$A9,$25,$A6,$49,$9B,$26,$A5,$2E,$B5,$2B,$63,$04
 .db $94,$81,$AF,$90,$81,$AF,$65,$A5,$27,$AF,$B6,$48,$2E,$A9,$25,$A6,$49
 .db $9B,$26,$A5,$2E,$A5,$2B,$63,$04,$94,$86,$AF,$90,$81,$68,$23,$A5,$24
 .db $AF,$B6,$48,$2E,$A9,$25,$A6,$49,$97,$26,$B5,$2E,$A9,$2A,$AF,$09,$9F
 .db $BD,$04,$9F,$65,$A5,$A9,$25,$AF,$B6,$48,$2E,$A9,$25,$A6,$49,$97,$A5
 .db $96,$B5,$2E,$A9,$29,$AB,$B0,$03,$94,$8B,$63,$90,$81,$43,$63,$A9,$44
 .db $25,$AB,$B6,$48,$96,$2B,$A9,$25,$A6,$49,$97,$25,$AE,$23,$A5,$2A,$A5
 .db $28,$AB,$B0,$03,$24,$AF,$B9,$04,$9A,$AB,$B9,$86,$A4,$03,$9A,$BD,$49
 .db $96,$A5,$28,$A9,$25,$A6,$49,$96,$26,$B9,$96,$A5,$24,$A5,$96,$2A,$AF
 .db $B0,$81,$44,$64,$A0,$04,$24,$BD,$90,$23,$05,$9B,$B6,$48,$96,$A5,$28
 .db $A9,$25,$A6,$49,$96,$A5,$23,$B9,$23,$A5,$24,$A5,$96,$A5,$26,$AB,$BC
 .db $03,$9F,$66,$90,$07,$9F,$90,$09,$9B,$B6,$48,$96,$B9,$28,$43,$25,$A6
 .db $49,$29,$B9,$23,$A9,$24,$A5,$96,$A5,$25,$AB,$63,$04,$AF,$66,$90,$07
 .db $43,$91,$90,$90,$03,$9B,$B6,$49,$9B,$A5,$28,$A9,$24,$A6,$49,$29,$B9
 .db $23,$A9,$23,$A9,$23,$A9,$25,$43,$64,$03,$9B,$66,$A4,$08,$A9,$91,$9A
 .db $A4,$03,$9A,$50,$2A,$BE,$24,$4F,$26,$BD,$23,$AD,$23,$A9,$24,$A5,$24
 .db $AF,$63,$04,$9F,$66,$A0,$07,$9A,$81,$43,$B9,$5B,$26,$5D,$B5,$96,$B5
 .db $23,$B5,$23,$B5,$25,$65,$04,$9F,$66,$A0,$07,$99,$86,$AF,$B9,$05,$9F
 .db $90,$03,$9F,$23,$63,$A5,$27,$63,$A5,$28,$AB,$A5,$28,$AE,$23,$AE,$23
 .db $AD,$24,$B9,$25,$AF,$BC,$03,$AF,$66,$90,$07,$9D,$86,$65,$A0,$03,$9E
 .db $90,$03,$9F,$23,$63,$A9,$27,$63,$A9,$28,$AB,$A5,$28,$AE,$24,$B9,$96
 .db $B5,$23,$B9,$25,$AF,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
 .db $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
 .db $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
 .db $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
 .db $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F
 .db $7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$7F,$6A,$8F
 .db $B0,$63,$83,$63,$8F,$63,$83,$72,$8F,$6D,$83,$7E,$06,$7E,$83,$B3,$B3
 .db $8F,$8F,$8F,$65,$8F,$71,$8F,$6E,$8F,$7E,$8F,$B3,$7E,$8F,$8F,$8C,$BC
 .db $B3,$67,$04,$BC,$83,$03,$66,$8C,$63,$05,$64,$04,$BC,$8C,$83,$B0,$8F
 .db $B0,$8F,$BC,$03,$65,$8C,$64,$04,$BC,$03,$73,$8F,$B0,$8F,$03,$B0,$8F
 .db $64,$8F,$B3,$B3,$BC,$67,$8C,$64,$8F,$B3,$B3,$BC,$63,$83,$63,$8F,$B3
 .db $8F,$B3,$B3,$68,$03,$63,$8F,$63,$8F,$75,$8F,$63,$8F,$BC,$B3,$B3,$64
 .db $8F,$B3,$BC,$B3,$66,$05,$63,$8F,$B3,$B3,$BC,$63,$8F,$63,$05,$B3,$BC
 .db $63,$03,$66,$8C,$64,$03,$63,$03,$74,$8F,$BC,$64,$8F,$8F,$8F,$63,$8F
 .db $B3,$BC,$B3,$66,$8F,$B3,$BC,$63,$8F,$8F,$B3,$BC,$65,$8F,$63,$8F,$83
 .db $65,$8F,$63,$8F,$B3,$64,$8F,$63,$8F,$70,$03,$BC,$64,$8F,$BC,$8F,$63
 .db $05,$65,$8F,$65,$03,$B0,$8C,$83,$03,$BC,$04,$B0,$8F,$63,$03,$63,$83
 .db $83,$04,$65,$06,$B0,$83,$B0,$83,$7F,$72,$8F,$7F,$7F,$7F,$7F,$8F,$7F
 .db $7F,$78
 .db $00
#endif

PJ2Game:
 .db $1F,$1F,$1F,$83,$64,$82,$43,$23,$81,$25,$AF,$64,$1F,$1F,$1F,$06,$65
 .db $82,$45,$90,$26,$AF,$64,$1F,$1F,$1F,$07,$64,$82,$45,$B0,$85,$23,$8F
 .db $63,$1F,$1F,$1F,$08,$64,$03,$96,$AB,$03,$25,$8F,$63,$1F,$1F,$1F,$08
 .db $64,$03,$23,$AB,$B0,$25,$8F,$63,$1F,$1F,$1F,$08,$64,$03,$23,$AB,$B0
 .db $25,$8F,$63,$1F,$1F,$1F,$08,$64,$03,$23,$AB,$B0,$25,$8F,$63,$1F,$1F
 .db $1F,$08,$64,$03,$23,$AB,$B0,$25,$8F,$63,$1F,$1F,$1F,$08,$64,$03,$96
 .db $AB,$03,$25,$8F,$63,$1F,$1F,$1F,$08,$64,$83,$45,$B0,$85,$23,$8F,$63
 .db $1F,$1F,$1F,$08,$64,$83,$45,$04,$25,$8F,$63,$06,$B0,$83,$8C,$B3,$BC
 .db $8F,$1F,$1F,$0F,$64,$83,$43,$94,$03,$25,$8F,$63,$06,$90,$81,$84,$91
 .db $03,$90,$1F,$1F,$0F,$64,$03,$25,$04,$9A,$94,$65,$06,$A0,$82,$88,$A2
 .db $03,$A8,$88,$1F,$1F,$0C,$64,$03,$25,$04,$44,$93,$64,$06,$B0,$83,$8C
 .db $B3,$B0,$83,$1F,$1F,$0F,$64,$03,$25,$04,$44,$93,$64,$06,$B0,$83,$83
 .db $83,$05,$B3,$1F,$1F,$0D,$64,$03,$25,$04,$43,$94,$65,$06,$64,$8C,$8C
 .db $8F,$B3,$B0,$1F,$1F,$0D,$66,$85,$25,$81,$9A,$A5,$64,$1F,$1F,$1F,$08
 .db $66,$85,$25,$81,$96,$A5,$63,$07
 .db $00

;
;This contains savegame
;
LevelSaved: .db 0,0,0,0,0,0,0,0
	    .db 0,0,0,0,0,0,0,0
	    .db 0,0,0,0,0,0,0,0

;Tabl1:
; .db  0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3
;Tabl2:
; .db  0, 0, 0, 1, 2, 3, 5, 6, 7, 8, 9,11,12,13,15,16
;Tabl3:
; .db 17,19,21,23,25,27,29,31,33,35,37,39,41,43,45,47

TotalAddr = 18
AddrTable:
 .db 1
 .dw SpriteGAP, SGAPC1
 .db 1
 .dw EraseBk, EBkC1
 .db 6
 .dw DrawLine, DLineC1, DLineC2, DLineC3, DLineC5, DLineC6, DLineC7
 .db 3
 .dw DrawScreen, DScreenC1, DScreenC2, DScreenC3
 .db 3
 .dw ClearDBuf, CBufC0, CBufC1, CBufC2
 .db 2
 .dw Copy2Active, C2ActC1, C2ActC2
 .db 1
 .dw DoScroll, DSclC1
 .db 1
 .dw DrwALine, DrwALineC1
 .db 1
 .dw WhiteLine, WLineC1
; .db 2
; .dw Tabl1, UseT1, UseT1_1
; .db 2
; .dw Tabl2, UseT2, UseT2_1
; .db 2
; .dw Tabl3, UseT3, UseT3_1
 .db 8
 .dw Rece_By, RB0, RB1, RB2, RB3, RB4, RB5, RB6, RB7
 .db 8
 .dw Send_By, SB0, SB1, SB2, SB3, SB4, SB5, SB6, SB7
 .db 3
 .dw Adjust, AdC0, AdC1, AdC2
 .db 2
 .dw AdjustErase, AdCE1, AdEC1
 .db 2
 .dw EMarble0, ImgL0, ImgL1
 .db 1
 .dw DoStarShip, DoSSC1
 .db 1
 .dw EraseStarShip, ErsSSC1
 .db 1
 .dw StarShip0, SSL1+1
 .db 2
 .dw GameLoop, J2Loop, J2Loop1

#ifndef _LITE
SpeedPics:
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0

 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$70,$00
 .db $FC,$00,$FC,$00

 .db $00,$00,$00,$00,$00,$00,$1C,$00,$3E,$00,$3F,$00,$7E,$00
 .db $FC,$00,$FC,$00

 .db $00,$38,$01,$F8,$07,$F8,$1F,$F8,$3F,$F0,$3F,$80,$7E,$00
 .db $FC,$00,$FC,$00

 .db $00,$3F,$01,$FF,$07,$FF,$1F,$FF,$3F,$F0,$3F,$80,$7E,$00
 .db $FC,$00,$FC,$00
#endif


#include graylibp.asm
#include gcp.asm
#include hiscorp.asm
#include fastcall.h
#include link.asm
#include loadlvl.h
#ifndef _LITE
#include pj2sng.h
#endif

End:

.end
